package com.xynet.marketing.service.factory.promotion.impl.base;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.Promotion;
import com.xynet.marketing.mapper.PromotionMapper;
import com.xynet.marketing.service.MercProjectDeviceService;
import com.xynet.marketing.service.MercProjectGoodsService;
import com.xynet.marketing.service.factory.promotion.PromotionFactory;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * 促销活动工厂-基类
 *
 * @author hechunping
 * @date 2025/1/21
 */
@Service
@Slf4j
@AllArgsConstructor
public class PromotionFactoryBase extends ServiceImpl<PromotionMapper, Promotion> implements PromotionFactory {

    private MercProjectGoodsService goodsService;

    private MercProjectDeviceService deviceService;

    @Override
    public Integer saveOrUpdate(JMap<String, Object> param) {
        Promotion save = BeanUtil.copyProperties(param, Promotion.class);
        if (Emptys.check(save.getId())) {
            updateById(save);
            //保存商品
            if (!save.getIsAllGoods()) {
                //删除原来的商品
                goodsService.removeByActId(save.getId());
            }
            //保存设备
            if (!save.getIsAllDevice()) {
                //删除原来的设备
                deviceService.removeByActId(save.getId());
            }
        } else {
            save(save);
        }
        //保存商品
        if (!save.getIsAllGoods()) {
            //删除原来的商品
            goodsService.saveBatchByActId(save.getId(), "promotion", param.getList("goodsList"));
        }
        //保存设备
        if (!save.getIsAllDevice()) {
            deviceService.saveBatchByActId(save.getId(), "promotion", param.getList("deviceList"));
        }

        return save.getId();
    }

    @Override
    public void updateSimple(JMap<String, Object> param) {
        Promotion save = BeanUtil.copyProperties(param, Promotion.class);
        updateById(save);
    }
}
