package com.xynet.marketing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.MercCoupon;
import com.xynet.marketing.mapper.MercCouponMapper;
import com.xynet.marketing.service.MercCouponService;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 商家优惠券服务-实现类
 *
 * @author hechunping
 * @date 2025/2/10
 */
@Service
@Slf4j
public class MercCouponServiceImpl extends ServiceImpl<MercCouponMapper, MercCoupon> implements MercCouponService {
    private LambdaQueryWrapper<MercCoupon> commonQueryWrapper(JMap<String, Object> param) {
        LambdaQueryWrapper<MercCoupon> lqw = new LambdaQueryWrapper<MercCoupon>()
                .eq(Emptys.check(param.getInt("id")), MercCoupon::getId, param.getInt("id"));
        return lqw;
    }

    @Override
    public Map<String, Object> obj(JMap<String, Object> param) {
        LambdaQueryWrapper<MercCoupon> lqw = commonQueryWrapper(param).last("limit 1");
        MercCoupon obj = getOne(lqw);
        return JHashMap.copy(obj);
    }

    @Override
    public Integer saveOrUpdate(JMap<String, Object> param) {
        return null;
    }

    @Override
    public List<Map<String, Object>> list(JMap<String, Object> param) {
        LambdaQueryWrapper<MercCoupon> lqw = commonQueryWrapper(param).orderByAsc(MercCoupon::getId);
        List<MercCoupon> list = list(lqw);
        return JHashMap.copy(list);
    }

    @Override
    public Page<Map<String, Object>> page(JMap<String, Object> param) {
        LambdaQueryWrapper<MercCoupon> lqw = commonQueryWrapper(param).orderByAsc(MercCoupon::getId);
        Page<MercCoupon> page = new Page<>(param.getInt("pageCurrent"), param.getInt("pageSize"), true);
        Page<MercCoupon> list = page(page, lqw);
        return JHashMap.copy(list);
    }

    @Override
    public void updateSimple(JMap<String, Object> param) {

    }
}
