package com.xynet.marketing.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.MercProjectGoods;
import com.xynet.marketing.mapper.MercProjectGoodsMapper;
import com.xynet.marketing.service.MercProjectGoodsService;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 项目商品服务 实现
 * @author hechunping
 * @date 2025/1/20
 */
@Service
@Slf4j
public class MercProjectGoodsServiceImpl extends ServiceImpl<MercProjectGoodsMapper, MercProjectGoods> implements MercProjectGoodsService {
    private LambdaQueryWrapper<MercProjectGoods> commonQueryWrapper(JMap<String,Object> param) {
        LambdaQueryWrapper<MercProjectGoods> lqw = new LambdaQueryWrapper<MercProjectGoods>()
                .eq(Emptys.check(param.getInt("id")), MercProjectGoods::getId, param.getInt("id"))
                ;
        return lqw;
    }

    @Override
    public Map<String, Object> obj(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProjectGoods> lqw = commonQueryWrapper(param).last("limit 1");
        MercProjectGoods obj = getOne(lqw);
        return JHashMap.copy(obj);
    }

    @Override
    public void saveOrUpdate(JMap<String, Object> param) {
        MercProjectGoods save = BeanUtil.copyProperties(param, MercProjectGoods.class);
        if(Emptys.check(save.getId())){
            updateById(save);
        }else{
            save(save);
        }
    }

    @Override
    public List<Map<String, Object>> list(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProjectGoods> lqw = commonQueryWrapper(param).orderByAsc(MercProjectGoods::getId);
        List<MercProjectGoods> list = list(lqw);
        return JHashMap.copy(list);
    }

    @Override
    public Page<Map<String, Object>> page(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProjectGoods> lqw = commonQueryWrapper(param).orderByAsc(MercProjectGoods::getId);
        Page<MercProjectGoods> page = new Page<>(param.getInt("pageCurrent"), param.getInt("pageSize"), true);
        Page<MercProjectGoods> list = page(page, lqw);
        return JHashMap.copy(list);
    }

    @Override
    public void removeByActId(Integer actId) {
        LambdaQueryWrapper<MercProjectGoods> lqw = new LambdaQueryWrapper<MercProjectGoods>()
                .eq(MercProjectGoods::getActId, actId);
        remove(lqw);
    }

    @Override
    public void saveBatchByActId(Integer actId, String actType, List<JMap<String, Object>> goodsList) {
        List<MercProjectGoods> saveGoodsList = new ArrayList<>();
        goodsList.forEach(goods -> {
            goods.put("actId", actId);
            goods.put("actType", actType);
            MercProjectGoods saveGoods = BeanUtil.copyProperties(goods, MercProjectGoods.class);
            saveGoodsList.add(saveGoods);
        });
        saveBatch(saveGoodsList);
    }
}
