package com.xynet.marketing.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.MercProject;
import com.xynet.marketing.mapper.MercProjectMapper;
import com.xynet.marketing.service.MercProjectService;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 商户项目服务
 * @author hechunping
 * @date 2025/1/20
 */
@Service
public class MercProjectServiceImpl extends ServiceImpl<MercProjectMapper, MercProject> implements MercProjectService {
    private LambdaQueryWrapper<MercProject> commonQueryWrapper(JMap<String,Object> param) {
        LambdaQueryWrapper<MercProject> lqw = new LambdaQueryWrapper<MercProject>()
                .eq(Emptys.check(param.getInt("id")), MercProject::getId, param.getInt("id"))
                ;
        return lqw;
    }

    @Override
    public Map<String, Object> obj(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProject> lqw = commonQueryWrapper(param).last("limit 1");
        MercProject obj = getOne(lqw);
        return JHashMap.copy(obj);
    }

    @Override
    public void saveOrUpdate(JMap<String, Object> param) {
        MercProject save = BeanUtil.copyProperties(param, MercProject.class);
        if(Emptys.check(save.getId())){
            updateById(save);
        }else{
            save(save);
        }
    }

    @Override
    public List<Map<String, Object>> list(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProject> lqw = commonQueryWrapper(param).orderByAsc(MercProject::getId);
        List<MercProject> list = list(lqw);
        return JHashMap.copy(list);
    }

    @Override
    public Page<Map<String, Object>> page(JMap<String, Object> param) {
        LambdaQueryWrapper<MercProject> lqw = commonQueryWrapper(param).orderByAsc(MercProject::getId);
        Page<MercProject> page = new Page<>(param.getInt("pageCurrent"), param.getInt("pageSize"),true);
        Page<MercProject> list = page(page, lqw);
        return JHashMap.copy(list);
    }
}
